<?php

function oauth_signature($url, $params)
{
    
    global $signature_key;
    
    // BUILD SIGNATURE
    // encode params keys, values, join and then sort.
    $keys = _urlencode_rfc3986(array_keys($params));
    $values = _urlencode_rfc3986(array_values($params));
    $params = array_combine($keys, $values);
    uksort($params, 'strcmp');

    // convert params to string
    foreach ($params as $k => $v) {$pairs[] = $k.'='.$v;}
    $concatenatedParams = implode('&', $pairs);

    // form base string (first key)
    $baseString= "GET&"._urlencode_rfc3986($url)."&"._urlencode_rfc3986($concatenatedParams);
    // create signature and append to params
    return _urlencode_rfc3986(base64_encode(hash_hmac('sha1', $baseString, $signature_key, TRUE)));
}


function _urlencode_rfc3986($input)
{
    if (is_array($input)) {
        return array_map('_urlencode_rfc3986', $input);
    }
    else if (is_scalar($input)) {
        return str_replace('+',' ',str_replace('%7E', '~', rawurlencode($input)));
    }
    else{
        return '';
    }
}

function full_path()
{
    $s = &$_SERVER;
    $ssl = (!empty($s['HTTPS']) && $s['HTTPS'] == 'on') ? true:false;
    $sp = strtolower($s['SERVER_PROTOCOL']);
    $protocol = substr($sp, 0, strpos($sp, '/')) . (($ssl) ? 's' : '');
    $port = $s['SERVER_PORT'];
    $port = ((!$ssl && $port=='80') || ($ssl && $port=='443')) ? '' : ':'.$port;
    $host = isset($s['HTTP_X_FORWARDED_HOST']) ? $s['HTTP_X_FORWARDED_HOST'] : (isset($s['HTTP_HOST']) ? $s['HTTP_HOST'] : null);
    $host = isset($host) ? $host : $s['SERVER_NAME'] . $port;
    $uri = $protocol . '://' . $host . $s['REQUEST_URI'];
    $segments = explode('?', $uri, 2);
    $url = $segments[0];
    return $url;
}
